import { defineComponent as d, computed as t, createBlock as u, openBlock as k, unref as r, normalizeStyle as h, normalizeClass as y } from "vue";
import f from "@vuepic/vue-datepicker";
/* empty css                                                                                                                                 */
import { useInject as w } from "../utils/index.js";
const B = /* @__PURE__ */ d({
  __name: "DatePicker",
  props: {
    width: { default: 150 },
    size: { default: "middle" },
    mode: { default: "date" },
    showTime: { type: Boolean, default: !1 },
    showToday: { type: Boolean, default: !1 },
    modelType: { default: "format" }
  },
  setup(l) {
    const e = l, { colorPalettes: a, shadowColor: i } = w("DatePicker"), n = t(() => typeof e.width == "number" ? `${e.width}px` : e.width), p = t(() => e.mode === "time"), m = t(() => e.mode === "week"), c = t(() => e.mode === "month"), s = t(() => e.mode === "year");
    return (o, b) => (k(), u(r(f), {
      class: y(["m-datepicker", {
        "datepicker-small": o.size === "small",
        "datepicker-large": o.size === "large"
      }]),
      style: h(`
      --datepicker-width: ${n.value};
      --datepicker-primary-color: ${r(a)[5]};
      --datepicker-primary-color-hover: ${r(a)[4]};
      --datepicker-primary-color-focus: ${r(a)[4]};
      --datepicker-primary-shadow-color: ${r(i)};
    `),
      locale: "zh-CN",
      position: "left",
      "month-change-on-scroll": !1,
      "enable-time-picker": o.showTime,
      "time-picker": p.value,
      "week-picker": m.value,
      "month-picker": c.value,
      "year-picker": s.value,
      "now-button-label": "今天",
      "show-now-button": o.showToday,
      "auto-apply": "",
      "text-input": "",
      "model-type": o.modelType,
      "day-names": ["一", "二", "三", "四", "五", "六", "七"]
    }, null, 8, ["class", "style", "enable-time-picker", "time-picker", "week-picker", "month-picker", "year-picker", "show-now-button", "model-type"]));
  }
});
export {
  B as default
};
