import { defineComponent as I, ref as L, computed as z, watch as J, nextTick as A, watchEffect as Q, onMounted as Z, onUnmounted as x, createElementBlock as a, openBlock as n, createVNode as r, withDirectives as p, Transition as R, withCtx as c, createElementVNode as o, normalizeStyle as u, vShow as y, withKeys as _, withModifiers as ee, normalizeClass as g, createCommentVNode as w, renderSlot as k, createTextVNode as d, toDisplayString as f, unref as b, normalizeProps as D, guardReactiveProps as N, mergeProps as C } from "vue";
import V from "../scrollbar/index.js";
import B from "../button/index.js";
const le = { class: "m-dialog-root" }, te = {
  focusable: "false",
  "data-icon": "fullscreen",
  width: "1em",
  height: "1em",
  fill: "currentColor",
  "aria-hidden": "true",
  viewBox: "64 64 896 896"
}, oe = {
  focusable: "false",
  "data-icon": "fullscreen-exit",
  width: "1em",
  height: "1em",
  fill: "currentColor",
  "aria-hidden": "true",
  viewBox: "64 64 896 896"
}, ae = {
  key: 1,
  class: "dialog-footer"
}, ne = {
  focusable: "false",
  "data-icon": "fullscreen",
  width: "1em",
  height: "1em",
  fill: "currentColor",
  "aria-hidden": "true",
  viewBox: "64 64 896 896"
}, se = {
  focusable: "false",
  "data-icon": "fullscreen-exit",
  width: "1em",
  height: "1em",
  fill: "currentColor",
  "aria-hidden": "true",
  viewBox: "64 64 896 896"
}, ie = {
  key: 1,
  class: "dialog-footer"
}, de = /* @__PURE__ */ I({
  __name: "Dialog",
  props: {
    width: { default: 520 },
    height: { default: "auto" },
    title: { default: void 0 },
    titleStyle: { default: () => ({}) },
    content: { default: void 0 },
    contentStyle: { default: () => ({}) },
    bodyClass: { default: void 0 },
    bodyStyle: { default: () => ({}) },
    scrollbarProps: { default: () => ({}) },
    cancelText: { default: "取消" },
    cancelProps: { default: () => ({}) },
    okText: { default: "确定" },
    okType: { default: "primary" },
    okProps: { default: () => ({}) },
    footer: { type: Boolean, default: !0 },
    destroyOnClose: { type: Boolean, default: !1 },
    switchFullscreen: { type: Boolean, default: !1 },
    centered: { type: Boolean, default: !1 },
    top: { default: 100 },
    transformOrigin: { default: "mouse" },
    confirmLoading: { type: Boolean, default: !1 },
    blockScroll: { type: Boolean, default: !0 },
    keyboard: { type: Boolean, default: !0 },
    maskClosable: { type: Boolean, default: !0 },
    maskStyle: { default: () => ({}) },
    open: { type: Boolean, default: !1 }
  },
  emits: ["update:open", "cancel", "ok"],
  setup(H, { emit: Y }) {
    const t = H, P = L(), i = L(null), m = L(), S = L(), v = L("50% 50%"), s = L(!1), $ = Y, O = z(() => typeof t.width == "number" ? `${t.width}px` : t.width), K = z(() => typeof t.height == "number" ? `${t.height}px` : t.height), W = z(() => typeof t.top == "number" ? `${t.top}px` : t.top), U = z(() => {
      var e, l;
      return s.value ? t.transformOrigin === "mouse" ? {
        width: "100%",
        transformOrigin: `${(e = i.value) == null ? void 0 : e.x}px ${(l = i.value) == null ? void 0 : l.y}px`
      } : {
        width: "100%",
        transformOrigin: v.value
      } : t.centered ? {
        width: O.value,
        transformOrigin: v.value
      } : {
        width: O.value,
        transformOrigin: v.value,
        top: W.value
      };
    }), T = z(() => s.value ? {
      height: "100vh",
      ...t.bodyStyle
    } : {
      height: K.value,
      ...t.bodyStyle
    });
    J(
      m,
      async (e) => {
        e ? (await A(), P.value.focus(), t.blockScroll && (document.documentElement.style.overflowY = "hidden", document.body.style.overflowY = "hidden")) : t.blockScroll && (document.documentElement.style.removeProperty("overflow-y"), document.body.style.removeProperty("overflow-y"));
      },
      {
        immediate: !0
      }
    ), Q(() => {
      m.value = t.open;
    }), Z(() => {
      document.addEventListener("click", M, !0);
    }), x(() => {
      document.removeEventListener("click", M, !0);
    });
    function M(e) {
      m.value || (i.value = {
        x: e.clientX,
        // 相对于浏览器视口左上角的 X 坐标，不页面滚动而改变
        y: e.clientY
        // 相对于浏览器视口左上角的 Y 坐标，不页面滚动而改变
      });
    }
    async function X(e) {
      if (S.value = !0, await A(), t.transformOrigin === "mouse" && i.value) {
        const l = e.getBoundingClientRect();
        v.value = `${i.value.x - l.left}px ${i.value.y - l.top}px`;
      } else
        v.value = "50% 50%";
    }
    function j(e) {
      if (t.transformOrigin === "mouse" && i.value) {
        const l = e.getBoundingClientRect();
        v.value = `${i.value.x - l.left}px ${i.value.y - l.top}px`;
      } else
        v.value = "50% 50%";
    }
    function q() {
      S.value = !1, s.value = !1;
    }
    function E() {
      s.value = !s.value;
    }
    function h() {
      m.value = !1, $("update:open", !1), $("cancel");
    }
    function F() {
      $("ok");
    }
    return (e, l) => (n(), a("div", le, [
      r(R, { name: "fade" }, {
        default: c(() => [
          p(o("div", {
            class: "dialog-mask",
            style: u(e.maskStyle)
          }, null, 4), [
            [y, m.value]
          ])
        ]),
        _: 1
      }),
      p(o("div", {
        tabindex: "-1",
        ref_key: "dialogRef",
        ref: P,
        class: g(["m-dialog-wrap", { "flex-centered": e.centered }]),
        onClick: l[0] || (l[0] = ee((G) => t.maskClosable ? h() : () => !1, ["self"])),
        onKeydown: l[1] || (l[1] = _((G) => t.keyboard ? h() : () => !1, ["esc"]))
      }, [
        r(R, {
          name: "zoom",
          "enter-from-class": "zoom-enter",
          "enter-active-class": "zoom-enter",
          "enter-to-class": "zoom-enter zoom-enter-active",
          "leave-from-class": "zoom-leave",
          "leave-active-class": "zoom-leave zoom-leave-active",
          "leave-to-class": "zoom-leave zoom-leave-active",
          onBeforeEnter: X,
          onBeforeLeave: j,
          onAfterLeave: q
        }, {
          default: c(() => [
            p(o("div", {
              class: g(["m-dialog", { "dialog-with-fullscreen": s.value }]),
              style: u(U.value)
            }, [
              e.destroyOnClose ? w("", !0) : (n(), a("div", {
                key: 0,
                class: g(["dialog-body-wrap", e.bodyClass]),
                style: u(T.value)
              }, [
                o("div", {
                  class: g(["dialog-header", { "header-with-switch": e.switchFullscreen }]),
                  style: u(e.titleStyle)
                }, [
                  k(e.$slots, "title", {}, () => [
                    d(f(e.title), 1)
                  ], !0)
                ], 6),
                e.switchFullscreen ? (n(), a("span", {
                  key: 0,
                  class: "fullscreen-action",
                  onClick: E
                }, [
                  p((n(), a("svg", te, l[2] || (l[2] = [
                    o("path", { d: "M290 236.4l43.9-43.9a8.01 8.01 0 00-4.7-13.6L169 160c-5.1-.6-9.5 3.7-8.9 8.9L179 329.1c.8 6.6 8.9 9.4 13.6 4.7l43.7-43.7L370 423.7c3.1 3.1 8.2 3.1 11.3 0l42.4-42.3c3.1-3.1 3.1-8.2 0-11.3L290 236.4zm352.7 187.3c3.1 3.1 8.2 3.1 11.3 0l133.7-133.6 43.7 43.7a8.01 8.01 0 0013.6-4.7L863.9 169c.6-5.1-3.7-9.5-8.9-8.9L694.8 179c-6.6.8-9.4 8.9-4.7 13.6l43.9 43.9L600.3 370a8.03 8.03 0 000 11.3l42.4 42.4zM845 694.9c-.8-6.6-8.9-9.4-13.6-4.7l-43.7 43.7L654 600.3a8.03 8.03 0 00-11.3 0l-42.4 42.3a8.03 8.03 0 000 11.3L734 787.6l-43.9 43.9a8.01 8.01 0 004.7 13.6L855 864c5.1.6 9.5-3.7 8.9-8.9L845 694.9zm-463.7-94.6a8.03 8.03 0 00-11.3 0L236.3 733.9l-43.7-43.7a8.01 8.01 0 00-13.6 4.7L160.1 855c-.6 5.1 3.7 9.5 8.9 8.9L329.2 845c6.6-.8 9.4-8.9 4.7-13.6L290 787.6 423.7 654c3.1-3.1 3.1-8.2 0-11.3l-42.4-42.4z" }, null, -1)
                  ]), 512)), [
                    [y, !s.value]
                  ]),
                  p((n(), a("svg", oe, l[3] || (l[3] = [
                    o("path", { d: "M391 240.9c-.8-6.6-8.9-9.4-13.6-4.7l-43.7 43.7L200 146.3a8.03 8.03 0 00-11.3 0l-42.4 42.3a8.03 8.03 0 000 11.3L280 333.6l-43.9 43.9a8.01 8.01 0 004.7 13.6L401 410c5.1.6 9.5-3.7 8.9-8.9L391 240.9zm10.1 373.2L240.8 633c-6.6.8-9.4 8.9-4.7 13.6l43.9 43.9L146.3 824a8.03 8.03 0 000 11.3l42.4 42.3c3.1 3.1 8.2 3.1 11.3 0L333.7 744l43.7 43.7A8.01 8.01 0 00391 783l18.9-160.1c.6-5.1-3.7-9.4-8.8-8.8zm221.8-204.2L783.2 391c6.6-.8 9.4-8.9 4.7-13.6L744 333.6 877.7 200c3.1-3.1 3.1-8.2 0-11.3l-42.4-42.3a8.03 8.03 0 00-11.3 0L690.3 279.9l-43.7-43.7a8.01 8.01 0 00-13.6 4.7L614.1 401c-.6 5.2 3.7 9.5 8.8 8.9zM744 690.4l43.9-43.9a8.01 8.01 0 00-4.7-13.6L623 614c-5.1-.6-9.5 3.7-8.9 8.9L633 783.1c.8 6.6 8.9 9.4 13.6 4.7l43.7-43.7L824 877.7c3.1 3.1 8.2 3.1 11.3 0l42.4-42.3c3.1-3.1 3.1-8.2 0-11.3L744 690.4z" }, null, -1)
                  ]), 512)), [
                    [y, s.value]
                  ])
                ])) : w("", !0),
                o("span", {
                  class: "close-action",
                  onClick: h
                }, l[4] || (l[4] = [
                  o("svg", {
                    width: "1em",
                    height: "1em",
                    fill: "currentColor",
                    viewBox: "64 64 896 896",
                    "data-icon": "close",
                    "aria-hidden": "true",
                    focusable: "false"
                  }, [
                    o("path", { d: "M563.8 512l262.5-312.9c4.4-5.2.7-13.1-6.1-13.1h-79.8c-4.7 0-9.2 2.1-12.3 5.7L511.6 449.8 295.1 191.7c-3-3.6-7.5-5.7-12.3-5.7H203c-6.8 0-10.5 7.9-6.1 13.1L459.4 512 196.9 824.9A7.95 7.95 0 0 0 203 838h79.8c4.7 0 9.2-2.1 12.3-5.7l216.5-258.1 216.5 258.1c3 3.6 7.5 5.7 12.3 5.7h79.8c6.8 0 10.5-7.9 6.1-13.1L563.8 512z" })
                  ], -1)
                ])),
                r(b(V), D(N(e.scrollbarProps)), {
                  default: c(() => [
                    o("div", {
                      class: "dialog-content",
                      style: u(e.contentStyle)
                    }, [
                      k(e.$slots, "default", {}, () => [
                        d(f(e.content), 1)
                      ], !0)
                    ], 4)
                  ]),
                  _: 3
                }, 16),
                e.footer ? (n(), a("div", ae, [
                  k(e.$slots, "footer", {}, () => [
                    r(b(B), C({
                      class: "mr8",
                      onClick: h
                    }, e.cancelProps), {
                      default: c(() => [
                        d(f(e.cancelText), 1)
                      ]),
                      _: 1
                    }, 16),
                    r(b(B), C({
                      type: e.okType,
                      loading: t.confirmLoading,
                      onClick: F
                    }, e.okProps), {
                      default: c(() => [
                        d(f(e.okText), 1)
                      ]),
                      _: 1
                    }, 16, ["type", "loading"])
                  ], !0)
                ])) : w("", !0)
              ], 6)),
              e.destroyOnClose && m.value ? (n(), a("div", {
                key: 1,
                class: g(["dialog-body-wrap", e.bodyClass]),
                style: u(T.value)
              }, [
                o("div", {
                  class: g(["dialog-header", { "header-with-switch": e.switchFullscreen }]),
                  style: u(e.titleStyle)
                }, [
                  k(e.$slots, "title", {}, () => [
                    d(f(e.title), 1)
                  ], !0)
                ], 6),
                e.switchFullscreen ? (n(), a("span", {
                  key: 0,
                  class: "fullscreen-action",
                  onClick: E
                }, [
                  p((n(), a("svg", ne, l[5] || (l[5] = [
                    o("path", { d: "M290 236.4l43.9-43.9a8.01 8.01 0 00-4.7-13.6L169 160c-5.1-.6-9.5 3.7-8.9 8.9L179 329.1c.8 6.6 8.9 9.4 13.6 4.7l43.7-43.7L370 423.7c3.1 3.1 8.2 3.1 11.3 0l42.4-42.3c3.1-3.1 3.1-8.2 0-11.3L290 236.4zm352.7 187.3c3.1 3.1 8.2 3.1 11.3 0l133.7-133.6 43.7 43.7a8.01 8.01 0 0013.6-4.7L863.9 169c.6-5.1-3.7-9.5-8.9-8.9L694.8 179c-6.6.8-9.4 8.9-4.7 13.6l43.9 43.9L600.3 370a8.03 8.03 0 000 11.3l42.4 42.4zM845 694.9c-.8-6.6-8.9-9.4-13.6-4.7l-43.7 43.7L654 600.3a8.03 8.03 0 00-11.3 0l-42.4 42.3a8.03 8.03 0 000 11.3L734 787.6l-43.9 43.9a8.01 8.01 0 004.7 13.6L855 864c5.1.6 9.5-3.7 8.9-8.9L845 694.9zm-463.7-94.6a8.03 8.03 0 00-11.3 0L236.3 733.9l-43.7-43.7a8.01 8.01 0 00-13.6 4.7L160.1 855c-.6 5.1 3.7 9.5 8.9 8.9L329.2 845c6.6-.8 9.4-8.9 4.7-13.6L290 787.6 423.7 654c3.1-3.1 3.1-8.2 0-11.3l-42.4-42.4z" }, null, -1)
                  ]), 512)), [
                    [y, !s.value]
                  ]),
                  p((n(), a("svg", se, l[6] || (l[6] = [
                    o("path", { d: "M391 240.9c-.8-6.6-8.9-9.4-13.6-4.7l-43.7 43.7L200 146.3a8.03 8.03 0 00-11.3 0l-42.4 42.3a8.03 8.03 0 000 11.3L280 333.6l-43.9 43.9a8.01 8.01 0 004.7 13.6L401 410c5.1.6 9.5-3.7 8.9-8.9L391 240.9zm10.1 373.2L240.8 633c-6.6.8-9.4 8.9-4.7 13.6l43.9 43.9L146.3 824a8.03 8.03 0 000 11.3l42.4 42.3c3.1 3.1 8.2 3.1 11.3 0L333.7 744l43.7 43.7A8.01 8.01 0 00391 783l18.9-160.1c.6-5.1-3.7-9.4-8.8-8.8zm221.8-204.2L783.2 391c6.6-.8 9.4-8.9 4.7-13.6L744 333.6 877.7 200c3.1-3.1 3.1-8.2 0-11.3l-42.4-42.3a8.03 8.03 0 00-11.3 0L690.3 279.9l-43.7-43.7a8.01 8.01 0 00-13.6 4.7L614.1 401c-.6 5.2 3.7 9.5 8.8 8.9zM744 690.4l43.9-43.9a8.01 8.01 0 00-4.7-13.6L623 614c-5.1-.6-9.5 3.7-8.9 8.9L633 783.1c.8 6.6 8.9 9.4 13.6 4.7l43.7-43.7L824 877.7c3.1 3.1 8.2 3.1 11.3 0l42.4-42.3c3.1-3.1 3.1-8.2 0-11.3L744 690.4z" }, null, -1)
                  ]), 512)), [
                    [y, s.value]
                  ])
                ])) : w("", !0),
                o("span", {
                  class: "close-action",
                  onClick: h
                }, l[7] || (l[7] = [
                  o("svg", {
                    width: "1em",
                    height: "1em",
                    fill: "currentColor",
                    viewBox: "64 64 896 896",
                    "data-icon": "close",
                    "aria-hidden": "true",
                    focusable: "false"
                  }, [
                    o("path", { d: "M563.8 512l262.5-312.9c4.4-5.2.7-13.1-6.1-13.1h-79.8c-4.7 0-9.2 2.1-12.3 5.7L511.6 449.8 295.1 191.7c-3-3.6-7.5-5.7-12.3-5.7H203c-6.8 0-10.5 7.9-6.1 13.1L459.4 512 196.9 824.9A7.95 7.95 0 0 0 203 838h79.8c4.7 0 9.2-2.1 12.3-5.7l216.5-258.1 216.5 258.1c3 3.6 7.5 5.7 12.3 5.7h79.8c6.8 0 10.5-7.9 6.1-13.1L563.8 512z" })
                  ], -1)
                ])),
                r(b(V), D(N(e.scrollbarProps)), {
                  default: c(() => [
                    o("div", {
                      class: "dialog-content",
                      style: u(e.contentStyle)
                    }, [
                      k(e.$slots, "default", {}, () => [
                        d(f(e.content), 1)
                      ], !0)
                    ], 4)
                  ]),
                  _: 3
                }, 16),
                e.footer ? (n(), a("div", ie, [
                  k(e.$slots, "footer", {}, () => [
                    r(b(B), C({
                      class: "mr8",
                      onClick: h
                    }, e.cancelProps), {
                      default: c(() => [
                        d(f(e.cancelText), 1)
                      ]),
                      _: 1
                    }, 16),
                    r(b(B), C({
                      type: e.okType,
                      loading: t.confirmLoading,
                      onClick: F
                    }, e.okProps), {
                      default: c(() => [
                        d(f(e.okText), 1)
                      ]),
                      _: 1
                    }, 16, ["type", "loading"])
                  ], !0)
                ])) : w("", !0)
              ], 6)) : w("", !0)
            ], 6), [
              [y, m.value]
            ])
          ]),
          _: 3
        })
      ], 34), [
        [y, S.value]
      ])
    ]));
  }
});
export {
  de as default
};
