import { defineComponent as D, ref as d, computed as v, createElementBlock as l, openBlock as t, Fragment as c, createBlock as a, createCommentVNode as o, unref as n, mergeProps as k, withCtx as i, renderList as b, resolveDynamicComponent as $, normalizeClass as C } from "vue";
import { useInject as H } from "../utils/index.js";
import { Swiper as z, SwiperSlide as E } from "swiper/vue";
import { Autoplay as _, Navigation as S, Pagination as M, Mousewheel as L, EffectCreative as V, EffectCards as W, EffectCoverflow as q, EffectFlip as G, EffectCube as J, EffectFade as K } from "swiper/modules";
/* empty css                                */
/* empty css                                            */
/* empty css                                            */
/* empty css                                             */
/* empty css                                             */
/* empty css                                             */
/* empty css                                              */
/* empty css                                                 */
const Q = ["src", "alt"], R = ["src"], T = ["src", "alt"], U = ["src"], X = ["src", "alt"], Y = ["src"], ue = /* @__PURE__ */ D({
  __name: "Swiper",
  props: {
    images: { default: () => [] },
    width: { default: "100%" },
    height: { default: "100%" },
    mode: { default: "banner" },
    navigation: { type: Boolean, default: !1 },
    effect: { default: "slide" },
    delay: { default: 3e3 },
    speed: { default: 300 },
    loop: { type: Boolean, default: !0 },
    pauseOnMouseEnter: { type: Boolean, default: !1 },
    swipe: { type: Boolean, default: !0 },
    preloaderColor: { default: "theme" }
  },
  emits: ["swiper", "change"],
  setup(O, { emit: j }) {
    const s = O, I = d({
      delay: s.delay,
      disableOnInteraction: !1,
      // 用户操作 swiper 之后，是否禁止 autoplay。默认为 true：停止。
      pauseOnMouseEnter: s.pauseOnMouseEnter
      // 鼠标置于 swiper 时暂停自动切换，鼠标离开时恢复自动切换，默认 false
    }), F = d([_]), N = d({
      delay: 0,
      disableOnInteraction: !1
    }), P = d([S, M, L]), { colorPalettes: f } = H("Swiper"), B = j, h = v(() => typeof s.width == "number" ? `${s.width}px` : s.width), w = v(() => typeof s.height == "number" ? `${s.height}px` : s.height), A = v(() => {
      const e = [S, M, _], p = {
        fade: K,
        cube: J,
        flip: G,
        coverflow: q,
        cards: W,
        creative: V
      };
      return s.effect !== "slide" && e.push(p[s.effect]), e;
    });
    function y(e) {
      B("swiper", e), s.mode === "carousel" && s.pauseOnMouseEnter && (e.el.onmouseenter = () => {
        e.autoplay.stop();
      }, e.el.onmouseleave = () => {
        e.autoplay.start();
      });
    }
    function m(e) {
      B("change", e);
    }
    function g(e) {
      if (e.name)
        return e.name;
      {
        const p = e.src.split("?")[0].split("/");
        return p[p.length - 1];
      }
    }
    return (e, p) => (t(), l(c, null, [
      e.mode === "banner" ? (t(), a(n(z), k({
        key: 0,
        class: ["swiper-banner", { "swiper-no-swiping": !e.swipe }],
        style: `
      --swiper-width: ${h.value};
      --swiper-height: ${w.value};
      --swiper-primary-color: ${n(f)[5]};
      --swiper-timing-function: cubic-bezier(0.65, 0, 0.35, 1);
    `,
        modules: A.value,
        navigation: e.navigation,
        "slides-per-view": 1,
        autoplay: I.value,
        effect: e.effect,
        speed: e.speed,
        loop: e.loop,
        lazy: "",
        onSwiper: y,
        onSlideChange: m
      }, e.$attrs), {
        default: i(() => [
          (t(!0), l(c, null, b(e.images, (r, u) => (t(), a(n(E), { key: u }, {
            default: i(() => [
              (t(), a($(r.link ? "a" : "div"), {
                class: "swiper-link",
                href: r.link,
                target: r.target ? r.target : "_blank"
              }, {
                default: i(() => [
                  r.src.match(/(jpg)|(png)|(gif)/g) ? (t(), l("img", {
                    key: 0,
                    class: "swiper-image w-100 h-100",
                    src: r.src,
                    alt: g(r),
                    loading: "lazy"
                  }, null, 8, Q)) : o("", !0),
                  r.src.match(/(mp4)/g) ? (t(), l("video", {
                    key: 1,
                    class: "swiper-video w-100 h-100",
                    src: r.src,
                    autoplay: "",
                    loop: ""
                  }, null, 8, R)) : o("", !0)
                ]),
                _: 2
              }, 1032, ["href", "target"])),
              r.src.match(/(mp4)/g) ? o("", !0) : (t(), l("div", {
                key: 0,
                class: C(`swiper-lazy-preloader swiper-lazy-preloader-${e.preloaderColor}`)
              }, null, 2))
            ]),
            _: 2
          }, 1024))), 128))
        ]),
        _: 1
      }, 16, ["class", "style", "modules", "navigation", "autoplay", "effect", "speed", "loop"])) : o("", !0),
      e.mode === "carousel" ? (t(), a(n(z), k({
        key: 1,
        class: "swiper-carousel swiper-no-swiping",
        style: `
      --swiper-width: ${h.value};
      --swiper-height: ${w.value};
      --swiper-primary-color: ${n(f)[5]};
      --swiper-timing-function: linear;
    `,
        modules: F.value,
        autoplay: N.value,
        speed: e.speed,
        loop: e.loop,
        lazy: "",
        onSwiper: y,
        onSlideChange: m
      }, e.$attrs), {
        default: i(() => [
          (t(!0), l(c, null, b(e.images, (r, u) => (t(), a(n(E), { key: u }, {
            default: i(() => [
              (t(), a($(r.link ? "a" : "div"), {
                class: "swiper-link",
                href: r.link,
                target: r.target ? r.target : "_blank"
              }, {
                default: i(() => [
                  r.src.match(/(jpg)|(png)|(gif)/g) ? (t(), l("img", {
                    key: 0,
                    class: "swiper-image w-100 h-100",
                    src: r.src,
                    alt: g(r),
                    loading: "lazy"
                  }, null, 8, T)) : o("", !0),
                  r.src.match(/(mp4)/g) ? (t(), l("video", {
                    key: 1,
                    class: "swiper-video w-100 h-100",
                    src: r.src,
                    autoplay: "",
                    loop: ""
                  }, null, 8, U)) : o("", !0)
                ]),
                _: 2
              }, 1032, ["href", "target"])),
              r.src.match(/(mp4)/g) ? o("", !0) : (t(), l("div", {
                key: 0,
                class: C(`swiper-lazy-preloader swiper-lazy-preloader-${e.preloaderColor}`)
              }, null, 2))
            ]),
            _: 2
          }, 1024))), 128))
        ]),
        _: 1
      }, 16, ["style", "modules", "autoplay", "speed", "loop"])) : o("", !0),
      e.mode === "broadcast" ? (t(), a(n(z), k({
        key: 2,
        class: "swiper-broadcast",
        style: `
      --swiper-width: ${h.value};
      --swiper-height: ${w.value};
      --swiper-primary-color: ${n(f)[5]};
      --swiper-timing-function: cubic-bezier(0.65, 0, 0.35, 1);
    `,
        modules: P.value,
        navigation: e.navigation,
        speed: e.speed,
        loop: e.loop,
        lazy: "",
        onSwiper: y,
        onSlideChange: m
      }, e.$attrs), {
        default: i(() => [
          (t(!0), l(c, null, b(e.images, (r, u) => (t(), a(n(E), { key: u }, {
            default: i(() => [
              (t(), a($(r.link ? "a" : "div"), {
                class: "swiper-link",
                href: r.link,
                target: r.target ? r.target : "_blank"
              }, {
                default: i(() => [
                  r.src.match(/(jpg)|(png)|(gif)/g) ? (t(), l("img", {
                    key: 0,
                    class: "swiper-image w-100 h-100",
                    src: r.src,
                    alt: g(r),
                    loading: "lazy"
                  }, null, 8, X)) : o("", !0),
                  r.src.match(/(mp4)/g) ? (t(), l("video", {
                    key: 1,
                    class: "swiper-video w-100 h-100",
                    src: r.src,
                    autoplay: "",
                    loop: ""
                  }, null, 8, Y)) : o("", !0)
                ]),
                _: 2
              }, 1032, ["href", "target"])),
              r.src.match(/(mp4)/g) ? o("", !0) : (t(), l("div", {
                key: 0,
                class: C(`swiper-lazy-preloader swiper-lazy-preloader-${e.preloaderColor}`)
              }, null, 2))
            ]),
            _: 2
          }, 1024))), 128))
        ]),
        _: 1
      }, 16, ["style", "modules", "navigation", "speed", "loop"])) : o("", !0)
    ], 64));
  }
});
export {
  ue as default
};
