import { defineComponent as R, ref as f, computed as o, watch as L, nextTick as M, onMounted as N, createElementBlock as h, openBlock as m, normalizeStyle as p, normalizeClass as v, unref as u, createElementVNode as g, createCommentVNode as T, withKeys as j } from "vue";
import { useInject as E } from "../utils/index.js";
const H = ["data-count"], _ = ["value", "placeholder", "maxlength", "disabled"], O = /* @__PURE__ */ R({
  __name: "Textarea",
  props: {
    width: { default: "100%" },
    allowClear: { type: Boolean, default: !1 },
    autoSize: { type: [Boolean, Object], default: !1 },
    disabled: { type: Boolean, default: !1 },
    placeholder: { default: void 0 },
    maxlength: { default: void 0 },
    showCount: { type: Boolean, default: !1 },
    value: { default: "" },
    valueModifiers: { default: () => ({}) }
  },
  emits: ["update:value", "change", "enter"],
  setup(x, { emit: w }) {
    const t = x, r = f(null), n = f(32), { colorPalettes: i, shadowColor: y } = E("Textarea"), z = o(() => typeof t.width == "number" ? `${t.width}px` : t.width), s = o(() => {
      if (typeof t.autoSize == "object") {
        const e = {
          height: `${n.value}px`,
          resize: "none"
        };
        return "minRows" in t.autoSize && (e["min-height"] = t.autoSize.minRows * 22 + 10 + "px"), "maxRows" in t.autoSize && (e["max-height"] = t.autoSize.maxRows * 22 + 10 + "px"), e;
      }
      if (typeof t.autoSize == "boolean")
        return t.autoSize ? {
          height: `${n.value}px`,
          resize: "none"
        } : {};
    }), d = o(() => !t.disabled && t.allowClear && t.value), C = o(() => t.maxlength ? `${t.value.length} / ${t.maxlength}` : t.value.length), S = o(() => "lazy" in t.valueModifiers);
    L(
      () => t.value,
      async () => {
        JSON.stringify(s.value) !== "{}" && (n.value = 32, await M(), c());
      },
      {
        flush: "post"
      }
    ), N(() => {
      c();
    });
    function c() {
      n.value = r.value.scrollHeight + 2;
    }
    const l = w;
    function b(e) {
      const a = e.target;
      S.value || (l("update:value", a.value), l("change", e));
    }
    function $(e) {
      const a = e.target;
      a.value !== t.value && (l("update:value", a.value), l("change", e));
    }
    function B(e) {
      l("enter", e);
    }
    function k() {
      var e;
      l("update:value", ""), (e = r.value) == null || e.focus();
    }
    return (e, a) => (m(), h("div", {
      class: v(["m-textarea", { "show-count": e.showCount }]),
      style: p(`
      --textarea-width: ${z.value};
      --textarea-primary-color-hover: ${u(i)[4]};
      --textarea-primary-color-focus: ${u(i)[4]};
      --textarea-primary-shadow-color: ${u(y)};
    `),
      "data-count": C.value
    }, [
      g("textarea", {
        ref_key: "textareaRef",
        ref: r,
        type: "hidden",
        class: v(["textarea-item", { "clear-class": d.value, "textarea-disabled": e.disabled }]),
        style: p(s.value),
        value: e.value,
        placeholder: e.placeholder,
        maxlength: e.maxlength,
        disabled: e.disabled,
        onInput: b,
        onChange: $,
        onKeydown: j(B, ["enter"])
      }, null, 46, _),
      d.value ? (m(), h("svg", {
        key: 0,
        class: "clear-svg",
        onClick: k,
        focusable: "false",
        "data-icon": "close-circle",
        width: "1em",
        height: "1em",
        fill: "currentColor",
        "aria-hidden": "true",
        viewBox: "64 64 896 896"
      }, a[0] || (a[0] = [
        g("path", { d: "M512 64C264.6 64 64 264.6 64 512s200.6 448 448 448 448-200.6 448-448S759.4 64 512 64zm165.4 618.2l-66-.3L512 563.4l-99.3 118.4-66.1.3c-4.4 0-8-3.5-8-8 0-1.9.7-3.7 1.9-5.2l130.1-155L340.5 359a8.32 8.32 0 01-1.9-5.2c0-4.4 3.6-8 8-8l66.1.3L512 464.6l99.3-118.4 66-.3c4.4 0 8 3.5 8 8 0 1.9-.7 3.7-1.9 5.2L553.5 514l130 155c1.2 1.5 1.9 3.3 1.9 5.2 0 4.4-3.6 8-8 8z" }, null, -1)
      ]))) : T("", !0)
    ], 14, H));
  }
});
export {
  O as default
};
